require "import"
import "android.media.*"
import "java.io.File"
import "android.os.*"
import "android.content.*"
import "android.net.*"
import "android.widget.Button"
import "android.widget.LinearLayout"
import "android.view.View"
import "com.androlua.*"

local vibrator = this.getSystemService(this.VIBRATOR_SERVICE)
if vibrator then vibrator.vibrate(100) end

local folderPath = Environment.getExternalStorageDirectory().getAbsolutePath().."/jieshuo audio recordings/"
local file = File(folderPath)
if not file.exists() then success = file.mkdirs() end

-- وظيفة لتشغيل الموسيقى
function playMusic(player)
    if mp then
        mp.stop()
        mp.release()  -- التأكد من تحرير MediaPlayer بشكل صحيح
        mp = nil
    end

    mp = MediaPlayer()
    mp.setAudioStreamType(AudioManager.STREAM_MUSIC)
    mp.setDataSource(player)
    mp.prepare()
    mp.start()
    mp.setOnCompletionListener {
        onCompletion = function()
            mp.release()
            mp = nil
        end
    }
    return true
end

-- خيارات معدل البت
local bitRateNames = {"32 كيلو بت", "64 كيلو بت", "96 كيلو بت", "128 كيلو بت", "160 كيلو بت", "192 كيلو بت", "256 كيلو بت", "320 كيلو بت"}
local bitRateValues = {32000, 64000, 96000, 128000, 160000, 192000, 256000, 320000}

if not service.getSharedData("defaultAudioBitrate") then
    service.setSharedData("defaultAudioBitrate", bitRateValues[1])
end

-- حوار لاختيار معدل البت
local dlg = LuaDialog()
dlg.setCancelable(false)
dlg.setTitle("معدل البت")
dlg.setSingleChoiceItems(bitRateNames, table.find(bitRateValues, service.getSharedData("defaultAudioBitrate")) - 1)
dlg.setButton2("حفظ")
dlg.onItemClick = function(l, v, p, i)
    service.setSharedData("defaultAudioBitrate", bitRateValues[i])
end

-- منطق التركيز والتسجيل
local focus = service.getText(node)
if focus == "الرجوع" or focus == "الصفحة الرئيسية" then
    dlg.show()
    return
end

local dlg2 -- تعريف dlg2 هنا حتى يمكن الوصول إليه على مستوى عالمي

if mr then
    mr.pause()
    local focus2 = this.getText(node)
    local appName = this.getAppName(node)
    local dlg = LuaDialog()
    dlg.setTitle("تم إيقاف التسجيل مؤقتاً")
    dlg.setButton("استئناف التسجيل", function()
        mr.resume()
    end)
    dlg.setButton2("إيقاف التسجيل", function()
        mr.stop()
        mr.release()
        mr = nil
        if vibrator then vibrator.vibrate(100) end
        
        -- حوار بعد إيقاف التسجيل
        local layout = {
            LinearLayout,
            orientation = "vertical",
            {
                Button,
                text = "تشغيل",
                onClick = function()
                    playMusic(outputFile)
                end
            },
            {
                Button,
                text = "مشاركة",
                onClick = function()
                    service.shareFile(outputFile)
                end
            },
            {
                Button,
                text = "حذف",
                onClick = function()
                    os.remove(outputFile)
                    service.postSpeak(1200, "تم حذف التسجيل")
                    dlg2.dismiss()
                end
            },
            {
                Button,
                text = "فتح في مدير الملفات",
                onClick = function()
                    this.startActivity(Intent(Intent.ACTION_VIEW).setDataAndType(Uri.parse(folderPath), "resource/folder"))
                    dlg2.dismiss()
                end
            },
            {
                Button,
                text = "الانضمام الى قناة تليجرام",
                onClick = function()
                    local intent = Intent(Intent.ACTION_VIEW, Uri.parse("https://t.me/AndroidTechnologyForTheBlind"))
                    service.startActivity(intent)
                    dlg2.dismiss()
                 end
            }
}

        dlg2 = LuaDialog(this)
        dlg2.View = loadlayout(layout)
        dlg2.setCancelable(false)
        dlg2.setTitle("النتيجة "..fileName)
        dlg2.setButton2("إغلاق")
        dlg2.onDismiss = function()
            appName = nil
            focus2 = nil
            fileName = nil
            layout = nil
            dlg2 = nil
            this.playSoundGestureEnd()
        end
        dlg2.show()
    end)
    dlg.setButton3("إخفاء الحوار")
    dlg.show()
    this.postClick(500, {{"<إيقاف التسجيل"}})
else
    if fileName == nil then
        fileName = os.date("تسجيل_%d_%m_%y_%H_%M_%S.mp3")
        this.playSoundGestureBegin()
    end

    outputFile = folderPath..fileName
    mr = MediaRecorder()
    mr.setAudioSource(MediaRecorder.AudioSource.MIC)
    mr.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
    mr.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
    mr.setAudioEncodingBitRate(service.getSharedData("defaultAudioBitrate"))
    mr.setOutputFile(outputFile)
    mr.prepare()
    mr.start()
end